<template>
  <section class="[overflow-y:overlay]">
    <canvas ref="chartCanvas" />
  </section>
</template>

<script setup lang="ts">
import { ref, onMounted, watch } from 'vue';
import { Chart, ChartConfiguration } from 'chart.js';

const props = defineProps<{ options: ChartConfiguration }>();
const chartCanvas = ref<HTMLCanvasElement | null>(null);

let chart: Chart | null = null;

onMounted(() => {
  const ctx = chartCanvas.value!.getContext('2d');

  if (!ctx) {
    return console.warn('Could not get canvas context');
  }

  if (!chart) {
    chart = new Chart(ctx, props.options);
  }
});

watch(() => props.options, (options) => {
  if (!chart) return;

  chart.data.datasets = options.data.datasets as any;
  chart.update();
});
</script>
